if( !EmojiPrint ){
  var EmojiPrint = {};
}
EmojiPrint.Utility = {
  sanitize: function( c ){
    var ret = c;
    switch(c){
    case "<":
      ret = "&lt;";
      break;
    case ">":
      ret = "&gt;"
      break;
    case "&":
      ret = "&amp;";
      break;
    case "\"":
      ret = "&quot;";
      break;
    case "'":
      ret = "&#39;"
      break;
    }
    return ret;
  },
  url_to_link: function( content ){
    var pattern = /(https?:\/\/[-_.!~*'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)/g ;
    return content.replace(pattern,"<a href=\"$1\">$1</a>");
  },
  decode_quoted_printable: function( content ){
    var ret = '';
    var len = content.length;
    var pos = 0;
    while( pos < len ){
      var c1 = content.charAt(pos);
      pos++;
      if( c1 == '=' ){
	var c2 = content.charAt(pos);
	var c3 = content.charAt(pos+1);
	if( c2.charCodeAt() == 10 || c2.charCodeAt() == 13 ){
	  pos++;
	  if( c3.charCodeAt() == 10 || c3.charCodeAt() == 13 ){
	    pos++;
	  }
	}else{
	  ret += String.fromCharCode(parseInt("0x"+c2+c3));
	  pos+=2;
	}
      }else{
	ret += c1;
      }
    }
    return ret;
  },
  conv_jis2sjis: function( c1, c2 ){
    var c3 = c1 - 0x21;
    var c4 = c2;
    if( ( c3 & 1 ) == 1 ){
	c4 += 0x1F;
	if( c4 >= 0x7F ){
	    c4++;
	}
    }else{
	c4 += 0x7F;
    }
    c3 = c3 >> 1;
    if( c3 <= 0x1E ){
	c3 += 0x81;
    }else{
	c3 += 0xC1;
    }
    return c3*256+c4;
  }
};
